SELECT final.alloc_grp alloc_grp, 
   final.grp_id grp_id, 
   final.start_date start_date, 
   final.end_date end_date, 
   NVL(final.obs_id,0) obs_id, 
   COUNT(final.alloc_grp) alloc_grp_cnt,
   final.book_stat book_stat, 
   final.inv_type inv_type
  FROM (SELECT srmr.id res,
           av.avail,
           NVL (al.alloc, 0) alloc,
           NVL (al.alloc, 0) / av.avail * 100 alloc_pct,
           CASE
              WHEN NVL (al.alloc, 0) / av.avail * 100 < 80 THEN 1
              WHEN NVL (al.alloc, 0) / av.avail * 100 BETWEEN 80 AND 120 THEN 2
              WHEN NVL (al.alloc, 0) / av.avail * 100 > 120 THEN 3
           END grp_id,
           CASE
              WHEN NVL (al.alloc, 0) / av.avail * 100 < 80
              THEN
                 'A: Under Allocated (Less Than 80%)'
              WHEN NVL (al.alloc, 0) / av.avail * 100 BETWEEN 80 AND 120
              THEN
                 'B: Appropriately Allocated (Between 80-120%)'
              WHEN NVL (al.alloc, 0) / av.avail * 100 > 120
              THEN
                 'C: Over Allocated (Over 120%)'
           END alloc_grp,
           :param_obs obs_id, 
           to_date(substr(:param_startdate,1,10),'YYYY-MM-DD') start_date, 
           to_date(substr(:param_enddate,1,10),'YYYY-MM-DD') end_date,
           :param_booking_status book_stat, 
           :param_investment_type inv_type
      FROM srm_resources srmr
     INNER JOIN prj_resources prjr 
         ON srmr.id = prjr.prid AND prjr.prisrole = 0
     INNER JOIN (SELECT av.prj_object_id resource_id, 
                        SUM(av.slice) avail
                   FROM prj_blb_slices av
                  WHERE av.slice_request_id = 1 
                        AND av.slice > 0 
                        AND av.slice_date BETWEEN :param_startdate 
                                              AND :param_enddate
                  GROUP BY av.prj_object_id) av 
         ON srmr.id = av.resource_id
      LEFT JOIN (SELECT tm.prresourceid resource_id, 
                        SUM(al.slice) alloc
                   FROM inv_investments invi
                  LEFT OUTER JOIN inv_projects invp 
                      ON invi.id = invp.prid and invp.is_template = 0
                  INNER JOIN prteam tm 
                      ON invi.id = tm.prprojectid
                  INNER JOIN prj_blb_slices al 
                      ON tm.prid = al.prj_object_id 
                         AND al.slice_request_id = 10
                  WHERE invi.is_active = 1 
                        AND al.slice_date BETWEEN :param_startdate 
                                              AND :param_enddate 
                        AND tm.prbooking = @NVL@ ( :param_booking_status , tm.prbooking )
                        AND invi.odf_object_code = @NVL@ ( :param_investment_type ,invi.odf_object_code )
                  GROUP BY tm.prresourceid) al 
         ON srmr.id = al.resource_id
     WHERE srmr.is_active = 1
       and srmr.id in (SELECT tm.prresourceid resource_id
                   FROM inv_investments invi
                  INNER JOIN prteam tm 
                      ON invi.id = tm.prprojectid
                  INNER JOIN prj_blb_slices al 
                      ON tm.prid = al.prj_object_id 
                         AND al.slice_request_id = 10
                  WHERE invi.is_active = 1 
                        AND al.slice_date BETWEEN :param_startdate 
                                              AND :param_enddate 
                        AND tm.prbooking = @NVL@ ( :param_booking_status , tm.prbooking )
                        AND invi.odf_object_code = @NVL@ ( :param_investment_type ,invi.odf_object_code )) 
           AND (:param_obs is null 
                   OR   EXISTS (SELECT 1
                         FROM prj_obs_units_flat obsf
                        INNER JOIN prj_obs_associations obsa 
                            ON obsf.unit_id = obsa.unit_id and obsa.table_name = 'SRM_RESOURCES'
                        WHERE obsf.branch_unit_id = :param_obs 
                              AND obsa.record_id = srmr.id)
   )) final
 WHERE 1=1
AND NLS_UPPER(trim(final.alloc_grp)) LIKE NLS_UPPER(trim(:alloc_grp_wildcard)) ESCAPE '\'
AND final.alloc_grp IN (NULL)
AND final.alloc_grp = :alloc_grp
AND final.alloc_grp >= :alloc_grp_from
AND final.alloc_grp <= :alloc_grp_to
AND final.grp_id IN (NULL)
AND final.grp_id = :grp_id
AND final.grp_id >= :grp_id_from
AND final.grp_id <= :grp_id_to
AND final.start_date IN (NULL)
AND final.start_date = :start_date
AND final.start_date >= :start_date_from
AND final.start_date <= :start_date_to
AND final.end_date IN (NULL)
AND final.end_date = :end_date
AND final.end_date >= :end_date_from
AND final.end_date <= :end_date_to
AND NVL(final.obs_id,0) IN (NULL)
AND NVL(final.obs_id,0) = :obs_id
AND NVL(final.obs_id,0) >= :obs_id_from
AND NVL(final.obs_id,0) <= :obs_id_to
AND NLS_UPPER(trim(final.book_stat)) LIKE NLS_UPPER(trim(:book_stat_wildcard)) ESCAPE '\'
AND final.book_stat IN (NULL)
AND final.book_stat = :book_stat
AND final.book_stat >= :book_stat_from
AND final.book_stat <= :book_stat_to
AND NLS_UPPER(trim(final.inv_type)) LIKE NLS_UPPER(trim(:inv_type_wildcard)) ESCAPE '\'
AND final.inv_type IN (NULL)
AND final.inv_type = :inv_type
AND final.inv_type >= :inv_type_from
AND final.inv_type <= :inv_type_to
AND COUNT(final.alloc_grp) IN (NULL)
AND COUNT(final.alloc_grp) = :alloc_grp_cnt
AND COUNT(final.alloc_grp) >= :alloc_grp_cnt_from
AND COUNT(final.alloc_grp) <= :alloc_grp_cnt_to
GROUP BY final.alloc_grp, 
      final.grp_id,
      final.start_date,
      final.end_date,
      final.obs_id,
      final.book_stat,
      final.inv_type
HAVING 1=1